
/* this is eaglem.c */

/* this is a simple-minded random walk program. The Esc key will clear    */
/* the screen and put the walker in the middle. Use F3 to end to program. */

#define INCL_GPIBITMAPS
#define INCL_GPICONTROL
#define INCL_GPIPRIMITIVES
#define INCL_WININPUT
#define INCL_WINSYS
#define INCL_WINTIMER
#define INCL_WINWINMANAGER
#include <os2.h>
#include <stdio.h>
#include <stdlib.h>
#include "EAGLE.H"
#define PMG_CASU        ( KC_CTRL | KC_ALT | KC_SHIFT | KC_KEYUP )
#define PMG_PSO         ( PU_PELS | GPIF_DEFAULT | GPIT_MICRO | GPIA_ASSOC )
#define PMG_SWP         ( SWP_SIZE | SWP_MOVE | SWP_MAXIMIZE )
#define MY_TIMER        17
#define NUMCOLOR        25

/* #define PMGDEBUG  */
#ifdef  PMGDEBUG
#define PMGALLMSGS
FILE *fp;
#endif

int delay=0,ectr=0,erase=1500,rate=63;
long int colors[NUMCOLOR]={ CLR_RED,CLR_RED,CLR_RED,CLR_RED,
 CLR_YELLOW,CLR_YELLOW,CLR_YELLOW,CLR_YELLOW,CLR_CYAN,CLR_CYAN,CLR_GREEN,
 CLR_GREEN,CLR_GREEN,CLR_GREEN,CLR_GREEN,CLR_PINK,CLR_PINK,CLR_PINK,CLR_PINK,
 CLR_BLUE,CLR_BLUE,CLR_BLUE,CLR_BLUE,CLR_WHITE,CLR_WHITE }; 
HAB hab;
HMQ hmq;
HWND hwndFrame,hwndClient;
QMSG qmsg;
union { POINTL l; WPOINT s; SIZEL sizl; } corner;

MRESULT EXPENTRY ClientWindowProc(HWND hwnd,USHORT msg,MPARAM mp1,MPARAM mp2)
  {
  static HBITMAP hbm;
  static HDC hdcMemory;
  static HPS hpsMemory,hpsWindow;
  static int color,dir,tmp,zztop;
  static POINTL point,aptl[3];
#ifdef  PMGALLMSGS
  fprintf(fp,"msg=%4.4X, mp1.1=%4.4X, mp1.2=%4.4X mp2.1=%4.4X, mp2.2=%4.4X\n",
  msg,SHORT1FROMMP(mp1),SHORT2FROMMP(mp1),SHORT1FROMMP(mp2),SHORT2FROMMP(mp2) );
#endif
  switch (msg)
    {
  case WM_CREATE:
    srand(SHORT1FROMMP(mp1));
    color=0;
    dir=8;
    hdcMemory=DevOpenDC(hab,OD_MEMORY,"*",0L,NULL,NULL);
    hpsMemory=GpiCreatePS(hab,hdcMemory,&corner.sizl,PMG_PSO);
      {
      BITMAPINFOHEADER bmp;
      bmp.cbFix=sizeof(bmp);
      bmp.cx=corner.s.x;
      bmp.cy=corner.s.y;
      bmp.cPlanes=1;
      bmp.cBitCount=8;
      hbm=GpiCreateBitmap(hpsMemory,&bmp,0L,0L,NULL);
      }
    if ( NULL==hbm )
      {
      GpiDestroyPS(hpsMemory);
      DevCloseDC(hdcMemory);
      return (MRESULT) FALSE;
      }
    GpiSetBitmap(hpsMemory,hbm);
    aptl[1]=corner.l;
    GpiBitBlt(hpsMemory,NULL,2L,aptl,ROP_ZERO,BBO_OR);  /* BLACK */
    WinSetFocus(HWND_DESKTOP,hwnd);
    WinInvalidateRect(hwnd,NULL,TRUE);
    WinStartTimer(hab,hwnd,MY_TIMER,rate);
    point.x=corner.l.x>>1;
    point.y=corner.l.y>>1;
    return (MRESULT) FALSE;
  case WM_DESTROY:
    zztop=(short) colors[32000];   /* THIS WILL LIKELY BE TRAP D */
    GpiDestroyPS(hpsMemory);
    DevCloseDC(hdcMemory);
    GpiDeleteBitmap(hbm);
    return (MRESULT) FALSE;
  case WM_TIMER:
    if ( MY_TIMER!=SHORT1FROMMP(mp1) ) break;
    if ( delay=delay>0?delay-1:0 ) break;
    hpsWindow=WinGetPS(hwnd);
    GpiSetColor(hpsMemory,colors[color]);
    GpiSetColor(hpsWindow,colors[color]);
    GpiMove(hpsMemory,&point);
    GpiMove(hpsWindow,&point);
    if ( randommove(&color,&dir,&point,&corner.l) )
      {
      GpiLine(hpsMemory,&point);
      GpiLine(hpsWindow,&point);
      }
    WinReleasePS(hpsWindow);
    if ( ++ectr>erase ) 
      WinPostMsg(hwnd,WM_CHAR,MPFROM2SHORT(6,257),MPFROM2SHORT(0X11B,15));
      break;
  case WM_PAINT:
    hpsWindow=WinBeginPaint(hwnd,NULL,(PRECTL) aptl);
    aptl[2]=aptl[0];
    GpiBitBlt(hpsWindow,hpsMemory,3L,aptl,ROP_SRCCOPY,BBO_OR);
    WinEndPaint(hpsWindow);
    return (MRESULT) FALSE;
  case WM_CHAR:
    tmp=SHORT1FROMMP(mp1);
    if ( 0==(tmp & PMG_CASU ) && (tmp & KC_VIRTUALKEY) )
      {
#ifdef  PMGALLMSGS
  fprintf(fp,"msg=%4.4X, mp1.1=%4.4X, mp1.2=%4.4X mp2.1=%4.4X, mp2.2=%4.4X\n",
  msg,SHORT1FROMMP(mp1),SHORT2FROMMP(mp1),SHORT1FROMMP(mp2),SHORT2FROMMP(mp2) );
#endif
      if ( VK_F3==CHAR3FROMMP(mp2) ) 
        { /* f3 key */
        WinStopTimer(hab,hwnd,MY_TIMER);
        WinPostMsg(hwnd,WM_CLOSE,0L,0L);
        }
      if ( '\x1b'==CHAR1FROMMP(mp2) )
        { /* Esc character */
        aptl[1]=corner.l;
        aptl[0].x=aptl[0].y=ectr=0;
        GpiBitBlt(hpsMemory,NULL,2L,aptl,ROP_ZERO,BBO_OR); /* BLACK */
        WinInvalidateRect(hwnd,NULL,TRUE);
        point.x=corner.l.x>>1;
        point.y=corner.l.y>>1;
        delay=3;
        }
      }
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

int main(int argc, char *argv[])
  {
  static char szCC[]="Sketch";
  static ULONG flFrameFlags= FCF_TASKLIST;
  if ( 1<argc ) sscanf(argv[1],"%d",&rate);
  if ( 2<argc ) sscanf(argv[2],"%d",&erase);
#ifdef  PMGDEBUG
  if ( NULL==( fp=fopen("WINMSGS","w") ) ) return printf("open failed\n");
#endif
  hab=WinInitialize(0);
  hmq=WinCreateMsgQueue(hab,0); 
  WinRegisterClass(hab,szCC,ClientWindowProc,CS_SIZEREDRAW,0);
  corner.l.x=WinQuerySysValue(HWND_DESKTOP,SV_CXSCREEN);
  corner.l.y=WinQuerySysValue(HWND_DESKTOP,SV_CYSCREEN);
  hwndFrame=WinCreateStdWindow(HWND_DESKTOP,WS_VISIBLE,&flFrameFlags,
                               szCC,NULL,0L,NULL,0,&hwndClient);
  if ( NULL==hwndFrame ) WinMessageBox(HWND_DESKTOP,HWND_DESKTOP,
      "Unable to create bitmap",szCC,0,MB_OK | MB_ICONEXCLAMATION );
  else
    {
    WinSetWindowPos(hwndFrame,NULL,0,0,corner.s.x,corner.s.y,PMG_SWP);
    while ( WinGetMsg(hab,&qmsg,NULL,0,0) ) 
      WinDispatchMsg(hab,&qmsg);
    WinDestroyWindow(hwndFrame);
    }
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
#ifdef  PMGDEBUG
  fclose(fp);
#endif
  return 0;
  }
