
        .486P
        PUBLIC  main
        INCLUDELIB   OS2386.LIB

OSIZE   EQU     66H
inport  EQU     0378H          ;LPT1 DATA PORT - HARMLESS FOR TESTING
outport EQU     0378H          ;PARTICULARLY IF NO PRINTER ATTACHED


CODE32  SEGMENT DWORD USE32 PUBLIC 'CODE'
;       MOST OF THE CODE
CODE32  ENDS
CODE16  SEGMENT DWORD USE16 PUBLIC 'CODE'
;       INTERFACE TO IOPL SEGMENT
CODE16  ENDS
CODEIO  SEGMENT DWORD USE16 PUBLIC 'CODE'
;       IOPL SEGMENT ITSELF 
CODEIO  ENDS

STACK32 SEGMENT DWORD USE32 STACK  'STACK'
        DD      1024 DUP(?)
STACK32 ENDS
CONST32 SEGMENT DWORD USE32 PUBLIC 'CONST'
CONST32 ENDS
DATA32  SEGMENT DWORD USE32 PUBLIC 'DATA'
DATA32  ENDS
BSS32   SEGMENT DWORD USE32 PUBLIC 'BSS'
BSS32   ENDS

DGROUP  GROUP   STACK32, CONST32, BSS32, DATA32

        ASSUME  CS:FLAT, DS:FLAT, ES:FLAT, SS:FLAT

CONST32 SEGMENT                ;READ ONLY DATA GOES HERE
CONST32 ENDS

DATA32  SEGMENT                ;READ/WRITE DATA GOES HERE
DATA32  ENDS

CODEIO  SEGMENT

INALDX  PROC    FAR
        SUB     AX,AX                   ;clear high byte, maybe not necessary
        IN      AL,DX                   ;read the port requested
        RET
INALDX  ENDP 

OUTDXAL PROC    FAR
        OUT     DX,AL                   ;write to the port requested
        MOV     EAX,CR3                 ;trap 6
        RET
OUTDXAL ENDP 

CODEIO  ENDS
;
CODE16  SEGMENT

THUNKO1 PROC    FAR
        XCHG    AX,[EBP-14]             ;swap ax with left half of bp in stack
        SHL     AX,3                    ;thunk the e part of ebp by shifting,
        ADD     AX,7                    ;then add (ldt, pl=3) bits to get sel
        XCHG    AX,[EBP-14]             ;swap them back
        SUB     WORD PTR [EBP-16],16    ;account for 4 pushes in 32 bit mode
        LSS     SP,[EBP-16]             ;now get 16 bit stack, same place
        CALL    OUTDXAL                 ;call iopl segment - 16 bit
        ASSUME  SS:NOTHING     ;TO AVOID ERROR MSG
        MOV     AX,[BP-12]              ;get saved ss back
        ASSUME  SS:FLAT
        MOV     SS,AX                   ;set ss - hw won't stop at lea
        LEA     ESP,[EBP-8]             ;set esp from known content of ebp
        DB      OSIZE                   ;override to force 32 bit far return
        RET
THUNKO1 ENDP

THUNKI1 PROC    FAR
        MOV     AX,[EBP-14]             ;swap ax with left half of bp in stack
        SHL     AX,3                    ;think the e part of ebp by shift 3,
        ADD     AX,7                    ;then turn on ldt and pl3 bits in sel 
        MOV     [EBP-14],AX             ;save new ss, get previous ax back
        SUB     WORD PTR [EBP-16],16    ;adjust saved bp for 4 32 bit pushes
        LSS     SP,[EBP-16]             ;now we have a 16 bit stack
        CALL    INALDX                  ;call the 16 bit iopl segment
        ASSUME  SS:NOTHING     ;TO AVOID ERROR MSG 
        XCHG    AX,[BP-12]              ;save ax, get saved ss
        ASSUME  SS:FLAT
        MOV     SS,AX                   ;reload 32 bit ss
        LEA     ESP,[EBP-8]             ;fix esp from known ebp
        MOV     AX,[EBP-12]             ;get ax back, it is the return value
        DB      OSIZE                   ;override to force far 32 bit return
        RET
THUNKI1 ENDP
CODE16  ENDS
CODE32  SEGMENT
;
;FOLLOWING PROCEDURES MUST BE AT AN OFFSET LESS THAN 64K

THUNKO  PROC    NEAR
        PUSH    EBP                     ;standard
        MOV     EBP,ESP                 ;linkage
        PUSH    CS                      ;optimized far call simulated
        PUSH    OFFSET FLAT:THUNKO2     ;cs, eip onto stack
        PUSH    SS                      ;save for thunk layer
        PUSH    EBP                     ;save for thunk layer
        JMP     THUNKO1                 ;begin 16 bit addressing for code
THUNKO  ENDP

THUNKO2 PROC    FAR
        POP     EBP                     ;actually, standard linkage
THUNKO2 ENDP
                                ;FAKE OUT MASM - THUNK02 MUST BE FAR
THUNKO3 PROC    NEAR
        RET                             ;must have near return
THUNKO3 ENDP
THUNKI  PROC    NEAR
        PUSH    EBP                     ;standard
        MOV     EBP,ESP                 ;linkage
        PUSH    CS                      ;make look like
        PUSH    OFFSET FLAT:THUNKI2     ;32 bit far call
        PUSH    SS                      ;save for thunk layer
        PUSH    EBP                     ;save for thunk layer
        JMP     THUNKI1                 ;begin 16 bit addressing for code
THUNKI  ENDP

THUNKI2 PROC    FAR
        POP     EBP                     ;actually, this is standard linkage
THUNKI2 ENDP
                                ;FAKE OUT MASM - THUNKI2 MUST BE FAR
THUNKI3 PROC    NEAR
        RET                             ;must have near return
THUNKI3 ENDP

;PRECEEDING PROCEDURES MUST BE AT AN OFFSET LESS THAN 64K

;THESE PROCEDURES CAN GO ANYWHERE, LOCATION DOES NOT MATTER
main    PROC    NEAR
        PUSH    EBP                     ;do stack stuff
        MOV     EBP,ESP                 ;enter is slower on 486
;       SUB     ESP,0H                  ;sizeof(local data)

        MOV     DX,outport              ;SET IO port address
        MOV     AL,0FFH                 ;data to output
        CALL    THUNKO                  ;call io code

        MOV     DX,inport               ;set io port address
        CALL    THUNKI                  ;call io code

        SUB     EAX,EAX                 ;rc=0
        MOV     ESP,EBP
        POP     EBP
        RET     
main    ENDP
CODE32  ENDS
        END     main
