
/* this is goose.exe, a simple memory demonstration program. */

#define INCL_DOSNMPIPES
#define INCL_DOSPROCESS
#define INCL_DOSQUEUES
#define INCL_DOSSEMAPHORES
#define INCL_NOPMAPI
#include <os2.h>
#include <stdio.h>
#include "gander.h"


APIRET APIENTRY DosAllocThreadLocalMemory(ULONG cb, PULONG *p);
APIRET APIENTRY DosFreeThreadLocalMemory(ULONG *p);

#pragma data_seg(CONST)

const char pname[]="\\PIPE\\GOOSE\\MESSAGES";
const char qname[]="\\QUEUES\\GOOSE\\FIFO.QUE";
const char sname[]="\\SEM32\\GOOSE\\PIPE";

#pragma data_seg()

PIB *ppib;
TIB *ptib;

void _System spare(int parm)
  {
  ULONG *tlm;
  int awake;
  DosAllocThreadLocalMemory(1+parm,&tlm); 
  printf("thread %d local memory at %p\n",parm,tlm);
  tlm[0]=ppib->pib_ulpid;
  tlm[1]=ptib->tib_ordinal;
  tlm[2]=parm;
  for ( awake=0 ; awake<24*60*60 ; awake++ )
    {
    DosSleep(1000);
    if ( 59==(awake%60) ) printf("thread %u sleeping\n",parm);
    }
  return;
  }

int main(void)
  { 
  int ix,rc=0;
  pgbl g;
  pins i;
  HEV hev;
  HFILE hfile;
  HQUEUE hcque=0,hoque=0;
  HPIPE  hpipe=0;
  PID pid;
  REQUESTDATA qrequest;
  ULONG action,qel_len,pip_len,tid2,tid3;
  VOID *pdata;
  ULONG *tlm;
  char prty,mybuf[255];
  setbuf(stdout,NULL);
  DosGetInfoBlocks(&ptib,&ppib);
  DosAllocThreadLocalMemory(2,&tlm);
  printf("thread 1 local memory at %p\n",tlm);
  tlm[0]=ppib->pib_ulpid;
  tlm[1]=ptib->tib_ordinal;
  DosCreateThread(&tid2,(PFNTHREAD) spare,2,0,4096);
  DosSleep(500);
  DosCreateThread(&tid3,(PFNTHREAD) spare,3,0,4096);
  DosSleep(500);
  g=gbl();
  printf("dll global data is located at %p\n",g);
  i=ins();
  printf("dll instance data is located at %p\n",i);
  i->l=ppib->pib_ulpid;  /* set instance data */
  rc=DosCreateQueue(&hcque,QUE_FIFO,(char *) &qname);
  if ( 0!=rc && 332!=rc) return printf("rc from create queue was %d\n",rc); 
  if ( 0==rc )
    {
    printf("create queue handle is %x, open queue handle is %x\n",hcque,hoque);
    printf("rq will read from the queue\n");
    } 
  else
    {
    printf("queue already exists\n"); 
    rc=DosOpenQueue(&pid,&hoque,(char *) &qname);
    if ( rc ) return printf("rc from open queue was %d\n",rc); 
    rc=DosCreateNPipe((char*) &pname,&hpipe,NP_ACCESS_DUPLEX,
                      NP_WAIT+NP_TYPE_MESSAGE+NP_READMODE_MESSAGE+1,
                      512,512,30*60*1000);
    if ( rc ) return printf("unable to create named pipe, rc=%d\n",rc);
    printf("pipe created, handle=%x\n");
    rc=DosCreateEventSem((char *) &sname,&hev,0,0);
    if ( rc ) return printf("unable to create event sem for pipe, rc=%d\n",rc);
    printf("pipe sem created\n");
    rc=DosSetNPipeSem(hpipe,(HSEM) hev,1);
    if ( rc ) return printf("unable to set pipe sem, rc=%d\n",rc);
    printf("pipe sem set\n");
    printf("rp will read from the pipe\n");
    }
  printf("g? and i? will print the global or instance data\n");
  printf("g= and i= will copy into global or instance data\n");
  printf("use q, Q, or break to end program\n");
  while ( fgets(mybuf,sizeof(mybuf),stdin) )
    {
    if ( 'q'==(mybuf[0]|' ') ) break;
    if ( !strnicmp(mybuf,"rp",2) ) 
      {
      rc=DosConnectNPipe(hpipe);
      if ( rc ) return printf("unable to connect to named pipe, rc=%d\n",rc);
      printf("connected to pipe handle %x\n",hpipe);
      DosRead(hpipe,&mybuf,sizeof(mybuf),&pip_len);
      }
    if ( !strnicmp(mybuf,"rq",2) )
      {
      rc=DosOpen((char *) &pname,&hfile,&action,0,0,FILE_OPEN,
                OPEN_ACCESS_READWRITE + OPEN_SHARE_DENYREADWRITE +
                                OPEN_FLAGS_FAIL_ON_ERROR,NULL);
      if ( rc ) return printf("unable to open pipe, rc=%d\n",rc);
      printf("opened handle %x for pipe\n",hfile);
      rc=DosReadQueue(hcque,&qrequest,&qel_len,&pdata,0,DCWW_WAIT,&prty,0);
      if ( rc ) printf("rc from readqueue was %d\n",rc);
      }
    if ( !strnicmp(mybuf,"g?",2) ) printf("global data is [%s]\n",g->buf);
    if ( !strnicmp(mybuf,"i?",2) ) printf("instance data is [%s]\n",i->buf);
    for ( ix=0 ; mybuf[ix] ; ix++ ) 
      if ( mybuf[ix]<' ' ) break;
    mybuf[ix]='\0';
    if ( !strnicmp(mybuf,"g=",2) ) strcpy(g->buf,mybuf+2);
    if ( !strnicmp(mybuf,"i=",2) ) strcpy(i->buf,mybuf+2);
    }
  DosClose(hfile);
  DosClose(hev);
  DosClose(hpipe);
  DosCloseQueue(hoque);
  if ( hcque!=hoque && 0!=hcque ) DosCloseQueue(hcque);
  DosKillThread(tid2);
  DosKillThread(tid3);
  return 0;
  }
