
#define INCL_PM
#define INCL_WINHELP
#define INCL_WINSYS
#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#include "os2.h"
#include "stdio.h"
#include "string.h"
#include "time.h"
#include "stdlib.h"

#define NUMTHREADS 15

HWND hwnds[NUMTHREADS+1];
HMTX hmtxNever;
HEV  hevNever;

typedef struct _pmthread {
  PSZ   pszName;
  PFNWP pfnwp;
  LONG  x;
  LONG  y;
  LONG  cx;
  LONG  cy;
  LONG  lColor;
  LONG  ulId;
  } PMTHREAD;

void paintit (HWND hwnd)
  {
  HPS    hps;
  RECTL  rectl;
  LONG   lColor,ulId;
  POINTL ptl;
  CHAR   szId[4];
  hps=WinBeginPaint(hwnd,NULLHANDLE,&rectl);
  WinQueryPresParam(hwnd,PP_BACKGROUNDCOLORINDEX,
              0,NULL,sizeof(lColor),&lColor,0);
  WinFillRect(hps,&rectl,lColor);
  ulId=WinQueryWindowUShort(hwnd,QWS_ID);
  ptl.x=32;
  ptl.y=32;
  sprintf(szId,"%d",ulId);
/*GpiSetColor(hps, (0x687C & (1<<lColor)) ? CLR_BLACK : CLR_WHITE );*/
  GpiSetColor(hps, (0xE87C & (1<<lColor)) ? CLR_BLACK : CLR_WHITE );
  GpiCharStringAt(hps,&ptl,strlen(szId),szId);
  WinEndPaint(hps);
  return;
  }

MRESULT EXPENTRY FirstThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  hwnds[1]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    DosSleep(3*60*60*1000);
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY SecondThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  hwnds[2]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    DosExit(EXIT_THREAD,0);
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
   }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY ThirdThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  ULONG i;
  hwnds[3]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    for (i=1 ; i !=0 ; i++);
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY FourthThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  hwnds[4]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    WinSendMsg(hwnd,msg,mp1,mp2);
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY FifthThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  hwnds[5]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    WinPostMsg(hwnd,msg,mp1,mp2);
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY SixthThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  hwnds[6]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    WinSendMsg(hwnds[(rand() % NUMTHREADS)+1],msg,mp1,mp2);
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY SeventhThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  hwnds[7]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    WinPostMsg(hwnds[(rand() % NUMTHREADS)+1],msg,mp1,mp2);
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY EighthThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  HAB    hab;
  hwnds[8]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    hab=WinQueryAnchorBlock(hwnd);
    WinLoadString(hab,NULLHANDLE,1,20,0);
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY NinthThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  hwnds[9]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    DosEnterCritSec();
    WinSendMsg(hwnds[(rand() % NUMTHREADS)+1],msg,mp1,mp2);
    DosExitCritSec();
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY TenthThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  PID  pid;
  TID  tid;
  HWND hwndSuspend;
  hwnds[10]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    hwndSuspend=hwnds[(rand() % NUMTHREADS)+1];
    WinQueryWindowProcess(hwndSuspend,&pid,&tid);
    DosSuspendThread(tid);
    WinSendMsg(hwndSuspend,msg,mp1,mp2);
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY EleventhThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  hwnds[11]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    DosRequestMutexSem(hmtxNever,SEM_INDEFINITE_WAIT);
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY TwelvthThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  hwnds[12]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    DosWaitEventSem(hevNever,SEM_INDEFINITE_WAIT);
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY ThirteenthThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  hwnds[13]=hwnd;
  switch (msg)
   {
  case WM_BUTTON1DOWN:
    *(PULONG)((PBYTE)&hwnd-4)=0;
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY FourteenthThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  PID pid;
  TID tid;
  LONG i;
  hwnds[14]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    WinPostMsg(hwnds[15],msg,mp1,mp2);
    WinQueryWindowProcess(hwnds[15],&pid,&tid);
    for ( i=0 ; i!=-1 ; i++ )
      {
      DosSuspendThread(tid);
      WinQueryWindowUShort(hwnd,QWS_ID);
      DosResumeThread(tid);
      }
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

MRESULT EXPENTRY FifteenthThreadWndProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
  {
  LONG i;
  hwnds[15]=hwnd;
  switch (msg)
    {
  case WM_BUTTON1DOWN:
    for (i=0 ; i !=-1; i++)
      WinLoadPointer(HWND_DESKTOP,NULLHANDLE,2);
    break;
  case WM_PAINT:
    paintit(hwnd);
    break;
    }
  return WinDefWindowProc(hwnd,msg,mp1,mp2);
  }

void EXPENTRY OtherThread(PMTHREAD *ppmThread)
  { /* This is a generic PM thread */
  HAB   hab;
  HMQ   hmq;
  QMSG  qmsg;
  HWND  hwndOtherThread;
  struct { ULONG cb; ULONG id; ULONG cbp; ULONG lColor; } presparamMyColor;
  presparamMyColor.cb=12;
  presparamMyColor.id=PP_BACKGROUNDCOLORINDEX;
  presparamMyColor.cbp=4;
  presparamMyColor.lColor=ppmThread->lColor;
  DosCreateMutexSem(NULL,&hmtxNever,0,TRUE);
  DosCreateEventSem(NULL,&hevNever,0,FALSE);
  hab=WinInitialize(0);
  hmq=WinCreateMsgQueue(hab,0);
  WinCancelShutdown(hmq,TRUE);
  WinRegisterClass(hab,ppmThread->pszName,ppmThread->pfnwp,0,0);
  hwndOtherThread=WinCreateWindow(HWND_DESKTOP,ppmThread->pszName,
          ppmThread->pszName,WS_VISIBLE,ppmThread->x,ppmThread->y,
          ppmThread->cx,ppmThread->cy,HWND_DESKTOP,HWND_TOP,
          ppmThread->ulId,NULL,&presparamMyColor);
  while( WinGetMsg( hab,(PQMSG)&qmsg,NULLHANDLE,0,0 ) )
    { /* Message loop */
    if (qmsg.msg==WM_QUIT) break;
    WinDispatchMsg( hab,(PQMSG)&qmsg );
    }
  WinDestroyMsgQueue( hmq );
  WinTerminate( hab );
  return;
  }

int main(int argc,char **argv)
  {
  HAB  hab;
  HMQ  hmq;
  QMSG qmsg;
  TID tid1stThread,tid2ndThread,tid3rdThread,tid4thThread,tid5thThread;
  TID tid6thThread,tid7thThread,tid8thThread,tid9thThread,tid10thThread;
  TID tid11thThread,tid12thThread,tid13thThread,tid14thThread,tid15thThread;
  HWND hwndFirstThread;
  PMTHREAD pmthread[16];
  char names[16][10];
  int ix,iy,iz;
  for ( ix=0 ; ix<5 ; ix++ )
    for ( iy=0 ; iy<3 ; iy++ )
      {
      iz=1+3*ix+iy; 
      pmthread[iz].cx=pmthread[iz].cy=60;
      pmthread[iz].x=50+80*ix;
      pmthread[iz].y=210-80*iy;
      pmthread[iz].ulId=pmthread[iz].lColor=iz;
      sprintf(names[iz],"Thread %02d",iz);
      pmthread[iz].pszName=names[iz];
      }
  pmthread[2].pfnwp =SecondThreadWndProc;
  pmthread[3].pfnwp =ThirdThreadWndProc;
  pmthread[4].pfnwp =FourthThreadWndProc;
  pmthread[5].pfnwp =FifthThreadWndProc;
  pmthread[6].pfnwp =SixthThreadWndProc;
  pmthread[7].pfnwp =SeventhThreadWndProc;
  pmthread[8].pfnwp =EighthThreadWndProc;
  pmthread[9].pfnwp =NinthThreadWndProc;
  pmthread[10].pfnwp =TenthThreadWndProc;
  pmthread[11].pfnwp =EleventhThreadWndProc;
  pmthread[12].pfnwp =TwelvthThreadWndProc;
  pmthread[13].pfnwp =ThirteenthThreadWndProc;
  pmthread[14].pfnwp =FourteenthThreadWndProc;
  pmthread[15].pfnwp =FifteenthThreadWndProc;
  hab=WinInitialize(0);
  hmq=WinCreateMsgQueue(hab,0);
  WinRegisterClass(hab,"FirstThread",(PFNWP)FirstThreadWndProc,0,0);
  hwndFirstThread=WinCreateWindow(HWND_DESKTOP,"FirstThread",
                                 "First Thread",WS_VISIBLE,
                                 pmthread[1].x,pmthread[1].y,
                                 pmthread[1].cx,pmthread[ix].cy,
                                 HWND_DESKTOP,HWND_TOP,1,NULL,NULL);
  srand(hwndFirstThread);    /* Initialize the random number generator */
  /* The second thread is going to create a window which in response to a
  WM_BUTTON1DOWN,will exit the thread.  This will leave pm in a strange 
  state,since it will not have processed the message properly. */
  DosCreateThread(&tid2ndThread,(PFNTHREAD)OtherThread,
             (ULONG)&pmthread[2],0,0x4000);
  /* The third thread will create a window which in response
     to a WM_BUTTON1DOWN,will go into a very long loop. */
  DosCreateThread(&tid3rdThread,(PFNTHREAD)OtherThread,
        (ULONG)&pmthread[3],0,0x4000);
  /* The fourth thread will create a window which in response
   * to a WM_BUTTON1DOWN,will run off the end of the stack. */
  DosCreateThread(&tid4thThread,(PFNTHREAD)OtherThread,
                  (ULONG)&pmthread[4],0,0x4000);
  /* The fifth thread will create a window which in response
   * to a WM_BUTTON1DOWN,will continually post a msg to itself */
  DosCreateThread(&tid5thThread,(PFNTHREAD)OtherThread,
                  (ULONG)&pmthread[5],0,0x4000);
  /* The sixth thread will create a window which in response
   * to a WM_BUTTON1DOWN,will randomly send a WM_BUTTON1DOWN
   * msg to one of the various threads window. */
  DosCreateThread(&tid6thThread,(PFNTHREAD)OtherThread,
                  (ULONG)&pmthread[6],0,0x4000);
  DosCreateThread(&tid7thThread,(PFNTHREAD)OtherThread,
                  (ULONG)&pmthread[7],0,0x4000);
  DosCreateThread(&tid8thThread,(PFNTHREAD)OtherThread,
                  (ULONG)&pmthread[8],0,0x4000);
  DosCreateThread(&tid9thThread,(PFNTHREAD)OtherThread,
                  (ULONG)&pmthread[9],0,0x4000);
  DosCreateThread(&tid10thThread,(PFNTHREAD)OtherThread,
                  (ULONG)&pmthread[10],0,0x4000);
  DosCreateThread(&tid11thThread,(PFNTHREAD)OtherThread,
                  (ULONG)&pmthread[11],0,0x4000);
  DosCreateThread(&tid12thThread,(PFNTHREAD)OtherThread,
                  (ULONG)&pmthread[12],0,0x4000);
  DosCreateThread(&tid13thThread,(PFNTHREAD)OtherThread,
                  (ULONG)&pmthread[13],0,0x4000);
  DosCreateThread(&tid14thThread,(PFNTHREAD)OtherThread,
                   (ULONG)&pmthread[14],0,0x4000);
  DosCreateThread(&tid15thThread,(PFNTHREAD)OtherThread,
                   (ULONG)&pmthread[15],0,0x4000);
  while( WinGetMsg( hab,(PQMSG)&qmsg,NULLHANDLE,0,0 ) )
    { /* Message loop for thread 1 */
    if (qmsg.msg==WM_QUIT) break;
    WinDispatchMsg( hab,(PQMSG)&qmsg );
    }
  WinDestroyMsgQueue( hmq );
  WinTerminate( hab );
  return 0;
  }
